#ifndef VDR_STREAMDEV_MENU_H
#define VDR_STREAMDEV_MENU_H

#include <vdr/osd.h>

#include "client/remote.h"

class cStreamdevMenu: public cOsdMenu {
private:
	enum eSubmenus {
		sub_Start = os_User,
		subTimers,
		subRecordings,
		subSuspend,
		subSyncEPG
	};

protected:
	void SuspendServer(void);

public:
	cStreamdevMenu(void);
	virtual ~cStreamdevMenu(void);

	virtual eOSState ProcessKey(eKeys Key);
};

class cStreamdevMenuRecordingItem;

class cStreamdevMenuRecordings: public cOsdMenu {
private:
	char *m_Base;
	int   m_Level;

	static int               HelpKeys;
	static cRemoteRecordings Recordings;

protected:
	bool Open(bool OpenSubMenus = false);
	void SetHelpKeys();
	cRemoteRecording *cStreamdevMenuRecordings::GetRecording(
		cStreamdevMenuRecordingItem *Item);

	eOSState Select(void);
	eOSState Delete(void);
	eOSState Summary(void);

public:
	cStreamdevMenuRecordings(const char *Base = NULL, int Level = 0, 
			bool OpenSubMenus = false);
	virtual ~cStreamdevMenuRecordings();

	virtual eOSState ProcessKey(eKeys Key);
};

class cStreamdevMenuTimers: public cOsdMenu {
private:
	static cRemoteTimers Timers;

protected:
	eOSState Edit(void);
  eOSState New(void);
  eOSState Delete(void);
  eOSState OnOff(void);
  eOSState Summary(void);
  
	cRemoteTimer *CurrentTimer(void);

	void Refresh(void);

public:
	cStreamdevMenuTimers(void);
	virtual ~cStreamdevMenuTimers();
	
	virtual eOSState ProcessKey(eKeys Key);
};

#endif // VDR_STREAMDEV_MENU_H

