#ifndef VDR_STREAMDEV_PLAYER_H
#define VDR_STREAMDEV_PLAYER_H

#include <vdr/player.h>

class cFrame;
class cRingBufferFrame;
class cTBSocket;

class cStreamdevPlayer: public cPlayer, cThread {
private:
	bool m_Active;
	bool m_FirstPacket;
	
	cFrame           *m_ReadFrame;
	cFrame           *m_PlayFrame;
	cTBSocket        *m_Socket;
	cRingBufferFrame *m_RingBuffer;

protected:
	virtual void Activate(bool On);
	virtual void Action(void);

public:
	cStreamdevPlayer(const char *Filename);
	virtual ~cStreamdevPlayer();

	bool Active(void) const { return m_Active; }
};

class cStreamdevPlayerControl: public cControl {
private:
	bool m_Visible;

	cStreamdevPlayer *m_Player;

protected:
	bool Active(void) const { return m_Player ? m_Player->Active() : false; }

public:
	cStreamdevPlayerControl(const char *Filename);
	virtual ~cStreamdevPlayerControl();

	virtual void Hide();
	virtual eOSState ProcessKey(eKeys Key);
};

#endif // VDR_STREAMDEV_PLAYER_H

