#include <vdr/menuitems.h>

#include "client/setup.h"
#include "client/device.h"
#include "i18n.h"

cStreamdevClientSetup StreamdevClientSetup;

cStreamdevClientSetup::cStreamdevClientSetup(void) {
	StartClient = false;
	strcpy(RemoteIp, "");
	RemotePort  = 2004;
	StreamType  = stTS;
	StreamPIDS  = true;
	SyncEPG     = false;
}

bool cStreamdevClientSetup::SetupParse(const char *Name, const char *Value) {
	if      (strcmp(Name, "StartClient") == 0) StartClient = atoi(Value);
	else if (strcmp(Name, "RemoteIp") == 0) {
		if (strcmp(Value, "-none-") == 0)
			strcpy(RemoteIp, "");
		else
			strcpy(RemoteIp, Value);
	}
	else if (strcmp(Name, "RemotePort") == 0)  RemotePort = atoi(Value);
	else if (strcmp(Name, "StreamType") == 0)  StreamType = atoi(Value);
	else if (strcmp(Name, "StreamPIDS") == 0)  StreamPIDS = atoi(Value);
	else if (strcmp(Name, "SyncEPG") == 0)     SyncEPG = atoi(Value);
	else return false;
	return true;
}

cStreamdevClientMenuSetupPage::cStreamdevClientMenuSetupPage(void) {
	m_NewSetup = StreamdevClientSetup;

	AddBoolEdit (tr("Start Client"),       m_NewSetup.StartClient);
	AddIpEdit   (tr("Remote IP"),          m_NewSetup.RemoteIp);
	AddShortEdit(tr("Remote Port"),        m_NewSetup.RemotePort);
	AddTypeEdit (tr("Remote Streamtype"),  m_NewSetup.StreamType,  true);
	AddBoolEdit (tr("MultiPID Streaming"), m_NewSetup.StreamPIDS);
	AddBoolEdit (tr("Synchronize EPG"),    m_NewSetup.SyncEPG);
	SetCurrent(Get(0));
}

cStreamdevClientMenuSetupPage::~cStreamdevClientMenuSetupPage() {
}

void cStreamdevClientMenuSetupPage::Store(void) {
	if (m_NewSetup.StartClient != StreamdevClientSetup.StartClient) {
		if (m_NewSetup.StartClient)
			cStreamdevDevice::Init();
		else
			Interface->Info(tr("Please restart VDR to activate changes"));
	}

	if (m_NewSetup.StreamType != stTS)
		m_NewSetup.StreamPIDS = false;

	SetupStore("StartClient", m_NewSetup.StartClient);
	if (strcmp(m_NewSetup.RemoteIp, "") == 0)
		SetupStore("RemoteIp", "-none-");
	else
		SetupStore("RemoteIp",  m_NewSetup.RemoteIp);
	SetupStore("RemotePort",  m_NewSetup.RemotePort);
	SetupStore("StreamType",  m_NewSetup.StreamType);
	SetupStore("StreamPIDS",  m_NewSetup.StreamPIDS);
	SetupStore("SyncEPG",     m_NewSetup.SyncEPG);

	StreamdevClientSetup = m_NewSetup;

	cStreamdevDevice::ReInit();
}

