#ifndef VDR_STREAMDEV_CHANSTREAMER_H
#define VDR_STREAMDEV_CHANSTREAMER_H

#include <vdr/receiver.h>

#include "server/streamer.h"
#include "common.h"

class cChannel;
class cTSRemux;

class cStreamdevChanReceiver: public cReceiver {
	friend class cStreamdevChanStreamer;

private:
	const cChannel         *m_Channel;
	cStreamdevChanStreamer *m_Streamer;

protected:
	virtual void Activate(bool On);
	virtual void Receive(uchar *Data, int Length);

public:
	cStreamdevChanReceiver(const cChannel *Channel, int Priority, 
			cStreamdevChanStreamer *Streamer);
	virtual ~cStreamdevChanReceiver();
};

class cStreamdevChanStreamer: public cStreamdevStreamer {
private:
	int                     m_Priority;
	cDevice                *m_Device;
	cStreamdevChanReceiver *m_Receiver;
	cTSRemux               *m_Remux;
	eStreamType             m_StreamType;
	
protected:
	virtual uchar *Process(const uchar *Data, int &Count, int &Result);

public:
	cStreamdevChanStreamer(int Priority, eStreamType StreamType, 
			cTBSocket *Socket);
	virtual ~cStreamdevChanStreamer();

	virtual void DetachAll(void);
	virtual void AttachAll(void);

	void SetDevice(cDevice *Device) { m_Device = Device; }
	bool SetChannel(const cChannel *Channel);
};

#endif // VDR_STREAMDEV_CHANSTREAMER_H

