#ifndef VDR_STREAMDEV_FILESTREAMER_H
#define VDR_STREAMDEV_FILESTREAMER_H

#include <vdr/thread.h>

#include "server/streamer.h"
#include "tools/file.h"

class cRingBufferLinear;
class cFileName;
class cStreamdevFileStreamer;

class cStreamdevFileReceiver: public cThread {
private:
	bool                    m_Active;
	bool                    m_Eof;
	cTBFile                 m_ReplayFile;
	cStreamdevFileStreamer *m_Streamer;
	cFileName              *m_FileName;
	cRecordings             m_Recordings;

protected:
	bool NextFile(uchar FileNumber = 0, int FileOffset = -1);

	virtual void Action(void);

public:
	cStreamdevFileReceiver(cRecording *Recording, 
			cStreamdevFileStreamer *Streamer);
	virtual ~cStreamdevFileReceiver();
};

class cStreamdevFileStreamer: public cStreamdevStreamer {
private:
	cStreamdevFileReceiver *m_Receiver;

public:
	cStreamdevFileStreamer(cTBSocket *Socket);
	virtual ~cStreamdevFileStreamer();

	virtual void DetachAll(void) {}
	virtual void AttachAll(void) {}

	bool SetFile(cRecording *Recording);
};

#endif // VDR_STREAMDEV_FILESTREAMER_H

