#ifndef VDR_STREAMDEV_PIDSTREAMER_H
#define VDR_STREAMDEV_PIDSTREAMER_H

#include <vdr/receiver.h>

#include "server/streamer.h"

#define MAXNUMRECEIVERS 16

class cDevice;

class cStreamdevPidReceiver: public cReceiver {
	friend class cStreamdevPidStreamer;

private:
	int                    m_Pid;
	cStreamdevPidStreamer *m_Streamer;

protected:
	virtual void Activate(bool On);
	virtual void Receive(uchar *Data, int Length);

public:
	cStreamdevPidReceiver(int Pid, int Priority, 
			cStreamdevPidStreamer *RingBuffer);
	virtual ~cStreamdevPidReceiver();
};

class cStreamdevPidStreamer: public cStreamdevStreamer {
private:
	int                    m_NumReceivers;
	int                    m_Priority;
	cDevice               *m_Device;
	cStreamdevPidReceiver *m_Receivers[MAXNUMRECEIVERS];

public:
	cStreamdevPidStreamer(int Priority, cTBSocket *Socket);
	virtual ~cStreamdevPidStreamer();

	virtual void DetachAll(void);
	virtual void AttachAll(void);

	void SetDevice(cDevice *Device) { m_Device = Device; }
	bool SetPid(int Pid, bool On);
};

#endif // VDR_STREAMDEV_PIDSTREAMER_H
