#ifndef VDR_STREAMDEV_STREAMER_H
#define VDR_STREAMDEV_STREAMER_H

#include <vdr/thread.h>
#include <vdr/ringbuffer.h>
#include <vdr/tools.h>

class cTBSocket;

class cStreamdevStreamer: public cThread {
private:
	bool               m_Active;
	int                m_Receivers;
	uchar             *m_Buffer;
	const char        *m_Name;
	cTBSocket         *m_Socket;
	cRingBufferLinear *m_RingBuffer;

protected:
	virtual uchar *Process(const uchar *Data, int &Count, int &Result);
	virtual void Action(void);

public:
	cStreamdevStreamer(const char *Name, cTBSocket *Socket);
	virtual ~cStreamdevStreamer();

	void Start(void);
	void Stop(void);

	void Activate(bool On);
	int Put(uchar *Data, int Length) { return m_RingBuffer->Put(Data, Length); }

	virtual void DetachAll(void) = 0;
	virtual void AttachAll(void) = 0;
};

#endif // VDR_STREAMDEV_STREAMER_H

